#include <Servo.h>
#include <Arduino.h>

//Diminua esse valor para aumentar a velocidade do servo
#define DELAY_SERVOS 38 // secs per angle in ms


//pino do lazer
#define LAZER 8

// define que area o lazer ira percorrer altere esses valores 
//de acordo com seu comodo
#define LIMITE_X_INICIAL 20//10
#define LIMITE_X_FINAL 90//66

#define LIMITE_Y_INICIAL 90//90
#define LIMITE_Y_FINAL 120//130

#define MAX_LENGTH_X LIMITE_X_INICIAL-LIMITE_X_FINAL
#define MAX_LENGTH_Y LIMITE_Y_FINAL-LIMITE_Y_INICIAL

int max_x=MAX_LENGTH_X ;
int max_y=MAX_LENGTH_Y; 
void line(uint8_t size, uint8_t direction);
void action_area();

Servo servo_y;
Servo servo_x;


uint8_t pos_x= MAX_LENGTH_X/2;
uint8_t pos_y= MAX_LENGTH_Y/2;

int lengthsX[6] = {max_x/1, max_x/2, max_x/4, 
                   max_x/8, max_x/16, max_x/32};

int lengthsY[6] = {max_y/1, max_y/2, max_y/4, 
                       max_y/8, max_y/16, max_y/32};


void setup() {


  //define quais I/Os seram usadas pelo servo
  servo_y.attach(2);
  servo_x.attach(3);

  //configura o I/O do lazer como saida
  pinMode(LAZER,OUTPUT);

  //ativa o lazer
  digitalWrite(LAZER ,1);
  
}

void loop() {


  int X=random(6);  
  int D=random(4);


  /*
   comente a funçao line(X, D); e 
   descomente a função action_area();
   fazer o ajuste da area de atuaçao do lazer
   */
  //action_area();
  line(X, D);
  

}

void line(uint8_t size, uint8_t direction){
  

  
  if(direction == 0){
    for(;pos_x>=lengthsX[size] ;pos_x-- ){
      servo_x.write(pos_x);
      if(pos_x<= LIMITE_X_INICIAL) break;  
      delay(DELAY_SERVOS);
    }
  }
  
  
  else if(direction == 1){
    for(;pos_x<=lengthsX[size] ;pos_x++ ){
      servo_x.write(pos_x);
      if(pos_x>= LIMITE_X_FINAL) break;
      delay(DELAY_SERVOS);
    }
  }

  else if(direction == 2){
    for(;pos_y>=lengthsY[size] ;pos_y-- ){
      servo_y.write(pos_y);
      if(pos_y<= LIMITE_Y_INICIAL) break;  
      delay(DELAY_SERVOS);
    }
  }

  else if(direction == 3){
    for(;pos_y<=lengthsY[size] ;pos_y++ ){
      servo_y.write(pos_y);
      if(pos_y>= LIMITE_Y_FINAL) break;
      delay(DELAY_SERVOS);
    }
  }
  
}


void action_area(){
  int x=LIMITE_X_INICIAL;
  int y=LIMITE_Y_INICIAL;

  servo_x.write(LIMITE_X_INICIAL);
  servo_y.write(LIMITE_Y_INICIAL);
  
  
  for(;x<LIMITE_X_FINAL;x++){
    servo_x.write(x);
    delay(DELAY_SERVOS);
  }

  for(;y<LIMITE_Y_FINAL;y++){
    servo_y.write(y);
    delay(DELAY_SERVOS);
  }

  for(;x>LIMITE_X_INICIAL;x--){
    servo_x.write(x);
    delay(DELAY_SERVOS);
  }

  for(;y>LIMITE_Y_INICIAL;y--){
    servo_y.write(y);
    delay(DELAY_SERVOS);
  }



}
